var selected_accordion = 0;
const index_multiply = 0x100;
var get_one_wire_xhr = new XMLHttpRequest();
var one_wire_count = 16;

function form_tag_tr(param_name, eds_index, eds_subindex)
{
    return form_tag_tr_param({name: param_name, index: eds_index, sub: eds_subindex})
}

function form_tag_tr_param(param)
{
    var tr = $('<tr class="can_hide">').append($('<td>').text(param.name))//.addClass("name"));
	var div = $('<div>').addClass("tag").attr({"index": `${param.index.toString(16).toUpperCase()}:${param.sub}`});
    tr.append($('<td>').append(div))//.addClass("name"));
    return tr;
}

function form_tag_tr2(param_name, eds_index, eds_subindex, param_name2, eds_index2, eds_subindex2)
{
	return form_tag_tr2_param({name: param_name, index: eds_index, sub: eds_subindex, type: ""},
							{name: param_name2, index: eds_index2, sub: eds_subindex2, type: ""})
}

function form_tag_tr2_param(param1, param2)
{
    var tr = $('<tr class="can_hide">').append($('<td>').text(param1.name))//.addClass("name"));
	var div = $('<div>').addClass("tag").attr({"index": `${param1.index.toString(16).toUpperCase()}:${param1.sub}`});
	if ("type" in param1)
	{
		div.addClass(param1.type)
	}
    tr.append($('<td>').append(div))//.addClass("name"));
	//tr.append($('<td>'))//.addClass('empty_space'));
	if (param2.name != "")
	{
		tr.append($('<td>').text(param2.name).addClass("name"));
	}

	var div2 = $('<div>').addClass("tag").attr({"index": `${param2.index.toString(16).toUpperCase()}:${param2.sub}`});
	if ("type" in param2)
	{
		div2.addClass(param2.type)
	}
    tr.append($('<td>').append(div2))//.addClass("name"));
    return tr;
}

$(document).ready(function()
{
	get_set_value.show_main_view_intreface()
	show_internal_sensors()
	
	response_one_wire()
})

function response_one_wire_ready()
{
	var values = get_set_value.get_response_values(get_one_wire_xhr)
	//console.log(values)
	let sensors_ID = values//.filter(element => element !== "0x0");
	//console.log(sensors_ID)
	show_one_wire(sensors_ID)

    $("#boyan").accordion({ heightStyle: 'content', header: '.accordion-header', active: 0});
	$("#boyan").accordion( "option", "collapsible", true );

	user.parse_page()

	$('.can_hide').each(function( )
	{
		var form = $(this).children('.value_td').children('.tag').children('.apply_form')
		if ($(form).hasClass('empty')) $(this).hide()
	});

	$("div[index='1001:0']").hide()
	$(".tab-class").tabs();
}

function show_internal_sensors()
{	
	$("#io_settings").append($(`<h3>`).text(l100n.localize_string("int_Channels_header")))
	$("#io_settings").append($(`<div class="accordion-header">${l100n.localize_string("RTD Sensors")}</div>`));
	$("#io_settings").append(get_sensor_body());
}

function get_sensor_body()
{
	var count = 12;
	var start_index = 1
	var ul = $('<ul>')
	ul.append($(`<li><a href="#value-tab">${l100n.localize_string("input state")}</a></li>`))
	ul.append($(`<li><a href="#deadband_settings-tab">${l100n.localize_string("Deadband Settings")}</a></li>`))
	ul.append($(`<li><a href="#settings-tab">${l100n.localize_string("Settings")}</a></li>`))
	ul.append($(`<li><a href="#scaling-tab">${l100n.localize_string("Scaling")}</a></li>`))
	ul.append($(`<li><a href="#di-value-tab">${l100n.localize_string("di state")}</a></li>`))
	ul.append($(`<li><a href="#di-settings-tab">${l100n.localize_string("di Settings")}</a></li>`))	
	
	var value = $(`<tbody id="value-tab">`).addClass('nowrap_td').addClass('data_td')
	var scaling = $(`<tbody id="scaling-tab">`).addClass('nowrap_td').addClass('data_td')
	var deadband_settings = $(`<tbody id="deadband_settings-tab">`).addClass('nowrap_td').addClass('data_td')
	var settings = $(`<tbody id="settings-tab">`).addClass('nowrap_td').addClass('data_td')
	var value_tab = $(`<tbody id="di-value-tab">`).addClass('nowrap_td').addClass('data_td')
	var settings_tab = $(`<tbody id="di-settings-tab">`).addClass('nowrap_td').addClass('data_td')
	
	var value_head = $('<tr>').addClass('table_header').append($('<td colspan="1">').text(""))
	value_head.append($('<td colspan="1">').text(l100n.localize_string("value")))
	value_head.append($('<td colspan="1">').text(l100n.localize_string("Status DI")))
	value.append(value_head)	
	var deadband_head = $('<tr>').addClass('table_header').append($('<td colspan="1">').text(""))
	deadband_head.append($('<td colspan="1">').text(l100n.localize_string("Deadband Reference")))
	deadband_head.append($('<td colspan="1">').text(l100n.localize_string("Deadband, %")))
	deadband_settings.append(deadband_head)
	var scaling_head = $('<tr>').addClass('table_header').append($('<td colspan="1">').text(""))
	scaling_head.append($('<td colspan="1">').text(l100n.localize_string("Scaling")))
	scaling_head.append($('<td colspan="1">').text(l100n.localize_string("Offset")))
	scaling.append(scaling_head)
	var settings_head = $('<tr>').addClass('table_header').append($('<td colspan="1">').text(""))
	settings_head.append($('<td colspan="1">').text(l100n.localize_string("Input Sensor")))
	settings_head.append($('<td colspan="1">').text(l100n.localize_string("Filter time, ms")))
	settings.append(settings_head)

	var value_header = $('<tr>').addClass('table_header')
	value_header.append($('<td colspan="1">'))//.text(l100n.localize_string("Channel:")))
	value_header.append($('<td colspan="1">').text(l100n.localize_string("value")))
	value_header.append($('<td colspan="1">').text(l100n.localize_string("invert_polarity")))
	value_tab.append(value_header)

	var settings_header = $('<tr>').addClass('table_header')
	settings_header.append($('<td colspan="1">'))//.text(l100n.localize_string("Channel:")))
	settings_header.append($('<td colspan="1">').text(l100n.localize_string("invert_polarity")))
	settings_tab.append(settings_header)

	for (var eds_subindex = start_index; eds_subindex < start_index+count; eds_subindex++)
	{
		var eds_index = 0x3F39
		configuration.add_template({"index": `${eds_index.toString(16).toUpperCase()}_${eds_subindex}`,"template": "combobox", "commands": templates_commands.sensor_type_mtu()})
		var eds_index = 0x3F0F
		configuration.add_template({"index": `${eds_index.toString(16).toUpperCase()}_${eds_subindex}`,"template": "bit_value", "commands": templates_commands.di_status()})

		value.append(form_tag_tr2(`${eds_subindex}`, 0x3F31, eds_subindex, "", 0x3F0F, eds_subindex));
		scaling.append(form_tag_tr2(`${eds_subindex}`, 0x3F32, eds_subindex, "", 0x3F33, eds_subindex));
		deadband_settings.append(form_tag_tr2(`${eds_subindex}`, 0x3F3C, eds_subindex, "", 0x3F35, eds_subindex));
		settings.append(form_tag_tr2(`${eds_subindex}`, 0x3F39, eds_subindex, "", 0x3F34, eds_subindex));

		var value_params = {name: `${eds_subindex}`, index: 0x3F11, sub: eds_subindex}
		var invert_params = {name: "", index: 0x3F12, sub: eds_subindex, type: "ro"}
		value_tab.append(form_tag_tr2_param(value_params, invert_params));

		var invert2_params = {name: `${eds_subindex}`, index: 0x3F12, sub: eds_subindex}
		settings_tab.append(form_tag_tr_param(invert2_params));
	}

	var table = $('<table>')
	table.append(value).append(value_tab).append(scaling).append(deadband_settings).append(settings).append(settings_tab)
	var tabs_div = $('<div class="tab-class">').append(ul).append(table)
	var body_div = $('<div class="accordion-body">').append(tabs_div)
	return body_div
}

function show_one_wire(sensorsId)
{
	if (!$.isEmptyObject(sensorsId))
	{
		var h3 = $(`<h3>`).text(l100n.localize_string("ext_Channels_header"))
		var commands = [{"name": l100n.localize_string("not selected"), "command": "0x0"}]
		sensorsId.forEach(function(id, i) {
			commands.push({"name": id, "command": id})
		});

		var sensors_table = $('<table>');
		var table_head = $('<tr>').addClass('table_header')
		table_head.append($('<td colspan="1">').text(""))
	    table_head.append($('<td colspan="1">').text(l100n.localize_string("ext_Settings")))
		table_head.append($('<td colspan="1">').text(l100n.localize_string("AI Read Float")))
		sensors_table.append(table_head)
		
		var start_number = 1;
		var end_number = one_wire_count;
		for (var sensor_number = start_number; sensor_number <= end_number; sensor_number++)
		{
			configuration.add_template({"index": `4C08_${sensor_number}`,"template": "combobox", "commands": commands})
			var tr = $('<tr class="can_hide">').append($('<td>').text(`${l100n.localize_string("ext_Channel")} ${sensor_number} `))
			tr.append($('<td>').append($('<div class="sensor_select">').addClass("tag").attr({"index": `4C08:${sensor_number}`})))
			tr.append($('<td>').append($('<div>').addClass("tag").attr({"index": `4C31:${sensor_number}`})))
			sensors_table.append(tr)
		}

		var sensors_div = $('<div>').addClass("board")		
		var sensors_head = $('<div>').text(l100n.localize_string("1 Wire accordion header")).addClass("accordion-header")
		var sensors_body = $('<div>').append(sensors_table).addClass("accordion-body")
		$("#boyan").append(h3).append(sensors_head).append(sensors_body)
		$("#io_settings").append(sensors_div)

	}
	//console.log(configuration.data_type_template().templates)
}

function response_one_wire()
{
	// Request 1-Wire sensors
	var query2 = '/get_od_data.form?';
	var start_number = 1;
	var end_number = one_wire_count;
	for (var sensor_number = start_number; sensor_number <= end_number; sensor_number++)
	{
		if (sensor_number > start_number) { query2 += "&"; }
		query2 += `0x4C0A_${sensor_number}`; //sensor ID
	}
	get_one_wire_xhr.open('GET', query2, true);
	get_one_wire_xhr.send();
}

get_one_wire_xhr.onreadystatechange = function()
{
    //console.log(get_one_wire_xhr.readyState);
    if (get_one_wire_xhr.readyState == 4)
    {
        if (get_one_wire_xhr.status == 200)
        {
            response_one_wire_ready();
        }
        else
        {
            alert("Проверьте соединение с контроллером...");
        }
    }
}

$(document).on('click', '.accordion-header', function()
{
    selected_accordion = $(this).index();
});

$(document).on('value_loaded', 'div[tb_index="1001_0"]', function( e )
{
    var device_error = $(this).text()
    if (device_error > 0)
    {
        $('.device_status').addClass('device_error')
    }
    else
    {
        $('.device_status').removeClass('device_error')
    }

    $(this).removeClass('value_loaded')
});
